const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const crm_pipelines = sequelize.define(
    'crm_pipelines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_default: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  crm_pipelines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






















    db.crm_pipelines.hasMany(db.crm_stages, {
      as: 'crm_stages_pipeline',
      foreignKey: {
          name: 'pipelineId',
      },
      constraints: false,
    });


    db.crm_pipelines.hasMany(db.leads, {
      as: 'leads_pipeline',
      foreignKey: {
          name: 'pipelineId',
      },
      constraints: false,
    });










//end loop



    db.crm_pipelines.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });




    db.crm_pipelines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.crm_pipelines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return crm_pipelines;
};


